/* params:{
groupname：supplyapply_bankinfo
id：单据id  ko.observable('')
fileCount||fileSize:ko.observable(0) 文件数量
readonly: ko.observable(false)  false 是否可编辑 默认false
filepath :ko.observable('')  全路径
isTemp：true||false  是否临时上传  默认false 不是临时上传
tempId:ko.observable('') 外部传入的临时id
bindFile:如果isTemp：true    需要手动绑定
queryFile:外部触发查询
objectName:调用方业务类型  默认 "diwork_yuncai"
businessIdList：多源查询  类型 []||ko.observableArray('')
如
[{groupname:'supplyapply_add',objectName:'调用方业务类型可选默认diwork_yuncai '},
 {groupname:'supplyapply_1',objectName:'调用方业务类型可选默认diwork_yuncai '},"test"]

coopParams:{
  fileType:渲染的文件类型  主表 默认7  子表  默认2
  format：文件类型限定，如 ["jpg","png","pdf"]
  fileNumLimit|| maxCount：最多文件上传数量限制，不传或者0时，则不做限制
  fileSizeLimit||maxSize  ：单文件最大容量   默认204800（200M）
  canDownload: 是否可下载   默认true
  enablePersonalLimit: 权限控制  是否可以删除别人上传的文件  默认 false 都可以删除
  uploadBtnShowText：上传按钮显示文字
}
hasCopy  兼容 询价单复制场景 复制了文件 但是未上传新增附件 ，要调用一次绑定
子表可选参数
chooseText: 展示文字  默认  管理附件
modalTitle：弹框标题  默认  管理附件
required： 是否必填   仅展示红色 *  需外部校验
} */
import $ from 'jquery';
import ko from "knockout";
import getLang from '../u-fileupload/i18n'
import _ from "lodashmix";

const defaultObjectName = 'diwork_yuncai';
// promise 
var fileInitCallBack=null
var updateListData= ko.observableArray([])
function randomId() {
  return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
}
// 生成临时id
function initTempId () {
  return randomId() + randomId() + "-" +randomId() + "-" +
    randomId() + "-" + randomId() + randomId();
}

// 协同云组件加载需要时间, 如果页面刚进来就带有附件id(id, filepath), 会直接查询
//   可能无法触发协同云查询, 进而无法渲染组件, 故设定定时器查询协同云组件状态
let funclist = [];
let interval= null
var intervallist = [];
function intervalEnd() {
	if (interval) {
		intervallist.forEach((item, index) => {
			clearInterval(item);
		})
		intervallist = [];
		interval = null;
	}
}

function execCoopFunc(config, func){
  let yyc = window.YYCooperationBridge
  if(yyc){
    yyc.ready(func);
  }else{
    funclist.push(func);
    interval = setInterval(() => {
      if(window.YYCooperationBridge){
        intervalEnd()
        for (let i = 0; i < funclist.length; i++) {
          window.YYCooperationBridge.ready(funclist[i]);
        }
        funclist = []
      }
    }, 200);
    intervallist.push(interval)

  }
}

let  idsmap= {}
const resetFile = function (vm, params, config) {
  var ele = $("#" + vm.tempId());
  ele.empty();
  // ycloud.loading.hide();
  let id = config[config.type]();
  let isTemp = config.isTemp;
  if (!id || id == '' || id == '0') {
    isTemp = true;
  }
  if(params.tempId||config.isTemp){
    config.fileid=vm.tempId()
  }
  let coopParams = Object.assign({
    fileType: config.inTable ? 2 : 7,
    format: '',
    canDownload: true,
    enablePersonalLimit: false,
    // uploadBtnShowText: '上传附件',
    maxCount: 20, //最大上传文件数
    maxSize: 204800
  }, params.coopParams);
  
  var yyconfig = {
    el: ele[0],
    businessType: config.objectName,
    objectId: config.fileid,
    tempObjectId: config.fileid,
    fileType: coopParams.fileType,
    format: coopParams.format,
    apiHost: window.sessionStorage.getItem('XtDomainUrl'),
    isTemp,
    maxCount: params.fileNumLimit || coopParams.maxCount,
    maxSize: params.fileSizeLimit || coopParams.maxSize,
    auth: {
      canDownload: coopParams.canDownload,
      canDelete: !vm.readonly(),
      canUpload: !vm.readonly(),
      enablePersonalLimit: coopParams.enablePersonalLimit
    },
    targetTid_temp: params.cloneYcCrossTenantBuyerTenant,
    // uploadBtnShowText: coopParams.uploadBtnShowText,
    onFileDeleteCallBack (fid, fileCount) {
      // fid为文件id, fileCount为删除后的总文件数
      vm.fileCount(fileCount);
      config.filelist.dellist.push(fid);
      let index = _.findIndex(config.filelist.list(), ['id', fid]);
      if (index >= 0) {
        config.filelist.list.splice(index, 1);
      }
      index = _.findIndex(config.filelist.newlist, ['id', fid]);
      if (index >= 0) {
        config.filelist.newlist.splice(index, 1);
      }
      params.afterDelete && params.afterDelete(fid, config.filelist.list());
    },
    onFileUploadCallBack (fileJson) {
      vm.fileCount(fileJson.fileCounts);
      config.filelist.list.push(fileJson);
      config.filelist.newlist.push(fileJson); // 新上传数据放入此数组, 用于判断是否执行绑定操作
      params.onUploadSuccess && params.onUploadSuccess(fileJson, config.filelist.list());
    },
    // 下载前事件 
    onBeforeDownloadCallBack: params.beforeDownload || coopParams.onBeforeDownloadCallBack || function () {return true},
    // 预览前事件 
    onBeforePreviewCallBack: params.beforeDownload || coopParams.onBeforePreviewCallBack || function () {return true},
    isSearch: false,
    listData: config.filelist.list()
  };
  execCoopFunc(config, function () {
    var fn = () => {
      idsmap[vm.tempId()] = -1;
      window.YYCooperationBridge.YYRenderFile(yyconfig).then(function (res) {
        $('body>.cooperation-component-file').empty()
        fileInitCallBack = res;
        idsmap[vm.tempId()] = res;
        if (config.inTable) {
          config.opened = true;
        }
      });
    };
    var instance = idsmap[vm.tempId()];
    if (instance) {
      if (instance !== -1) {//不是第一次render
        instance.close();
        fn();
      } else {
        var i = setInterval(() => {
          if (idsmap[vm.tempId()] !== -1) {//第一次render结束
            idsmap[vm.tempId()].close();
            fn();
            clearInterval(i);
          }
        }, 100);
      }
    } else {
      fn();
    }
  });
}
const queryFile = function (vm, params, config) {
  let getAllListParams = [];
  let businessId = null;
  let objectName = params.objectName || defaultObjectName;
  if (config.type == 'businessId') {
    businessId = config.businessId()
    getAllListParams.push({
      businessId,
      objectName
    });
  } else {
    let id = params.id();
    businessId =params.groupname + ((id && id != '') ? id : vm.tempId())
    getAllListParams.push({
      businessId: businessId,
      objectName
    });
    if(params.tempId){
      getAllListParams.push({
        businessId: params.tempId(),
        objectName
      });
    }
  }
  if (params.businessIdList) {
    let business = [];
    if (params.businessIdList.subscribe) {
      business = params.businessIdList();
    } else {
      business = params.businessIdList;
    }
    if (business.length > 0) {
      business.forEach(function (item) {
        if (typeof item == 'string') {
          getAllListParams.push({
            businessId: item,
            objectName: objectName
          });
        } else if (item instanceof Object) {
          getAllListParams.push({
            businessId: item.businessId,
            objectName: item.objectName ? item.objectName : objectName
          });
        }
      });
    }
  }
  execCoopFunc(config, () => {    
    window.YYCooperationBridge.YYFormFileGetAllListByObjectId(
      _.uniqBy(getAllListParams, 'businessId'), false, window.sessionStorage.getItem('XtDomainUrl'), '','', '', params.cloneYcCrossTenantBuyerTenant
    ).then((res) => {
      if (res) {
        vm.fileCount(res.length);
        config.filelist.list(res);
        if(params.hasCopy){//兼容 询价单复制场景 复制了文件 但是未上传新增附件 ，要调用一次绑定
          config.filelist.newlist.push({hasCopy:'entrustReqList'})
        }
        config.fileid = businessId;
        config.objectName = objectName;
        if (!config.inTable) {
        resetFile(vm, params, config);
        }
      }
    });
  });
}

const clearFile = function (vm, params, config) {
  const filelist = config.filelist;
  filelist.list([]);
  filelist.newlist.splice(0);
  filelist.dellist.splice(0);
  if (config.inTable) {
    config.opened = false;
  }
  let id, fileid;
  if (config.type == 'businessId') {
    id = config.businessId();
    fileid = (config.isTemp||!id || id == '' || id == 0) ? vm.tempId() : id;
  } else {
    id = config.id();
    fileid = (config.isTemp||!id || id == '' || id == 0) ?vm.tempId() : params.groupname+id;
  }
  let objectName = params.objectName || defaultObjectName;
  config.fileid = fileid;
  config.objectName = objectName;
  setTimeout(function () {
    resetFile(vm, params, config);
  }, 50);
}

const updateFile = function (vm, params, config, refresh = true, force = false) {
  let newid;
  if (config.type == 'businessId') {
    newid = config.businessId();
  } else {
    newid = config.groupname + config.id();
  }
  let oldid
  if(config.isTemp){
    oldid=vm.tempId()
  }else{
    oldid = config.fileid;
  }
  let hasDel = config.filelist.dellist.length > 0;
  let hasNew = force||(config.filelist.newlist.length > 0 && ( oldid != newid));
  if (hasDel || hasNew) {
    execCoopFunc(config, () => {
      if (hasDel) {
        window.YYCooperationBridge.YYFormFilesTempStateDel({
          data: {
            fileIds: config.filelist.dellist,
            targetTid_temp: params.cloneYcCrossTenantBuyerTenant
          }
        }, function (res) {
          config.filelist.dellist.splice(0);
            if (hasNew) {  
              // 有新上传数据 执行绑定
              window.YYCooperationBridge.YYUploadedFilesBind([{
                oldObjectId: oldid,
                objectId: newid,
                bussinessType: defaultObjectName
              }], function () {
                if (refresh) {
                  queryFile(vm, params, config);
                }
                config.filelist.newlist.splice(0);
              });
            }
        }, window.sessionStorage.getItem('XtDomainUrl'), '', '', '', params.cloneYcCrossTenantBuyerTenant);
      } else if (hasNew) {  
        // 有新上传数据 执行绑定
        window.YYCooperationBridge.YYUploadedFilesBind([{
          oldObjectId: oldid,
          objectId: newid,
          bussinessType: defaultObjectName
        }], function () {
          if (refresh) {
            queryFile(vm, params, config);
          }
          config.filelist.newlist.splice(0);
        }, window.sessionStorage.getItem('XtDomainUrl'), '', '', '', params.cloneYcCrossTenantBuyerTenant);
      }
    });
  }
  if (hasNew) {
    config.fileid = newid;
  } else {
    if (refresh) {
      queryFile(vm, params, config);
    }
  }
}

//  不是临时上传 oldId已经被赋值   并且  id发生变化
/*if (!params.isTemp &&oldId!='oldId'&& oldId != params.id()) {
  var newAttachmentIdList = [
    {
      sourceObjectName: "diwork_yuncai",
      sourceObjectId: sourceObjectId,
      targetObjectName: "diwork_yuncai",
      targetObjectId: params.groupname + val,
    },
  ];
  var callback = function () { };
  // 更改id
  window.YYCooperationBridge &&
    window.YYCooperationBridge.YYFormFilesCopyAll(
      newAttachmentIdList,
      callback
    );
  loaded = true;
}*/

const initVM = function (params, config) {

  this.fileCount = params.fileCount || params.fileSize ||params.filesize|| ko.observable(0);
  if(params.readonly){
    if(ko.isObservable(params.readonly) ){
      this.readonly = params.readonly
    }else{
      this.readonly = ko.observable(params.readonly)
    }
  }else{
    this.readonly = ko.observable(false)
  }
  config.isTemp = !!params.isTemp;
  // this.tempId = params.tempId|| ko.observable(initTempId());
  if (params.filepath && ko.isObservable(params.filepath)) {
    config.type = 'businessId';
    config.businessId = params.filepath;
  } else if (params.id && ko.isObservable(params.id)) {
    config.type = 'id';
    config.id = params.id;
    config.groupname = params.groupname;
  }
  // 原附件组件中的filelist可以传递列表进组件直接显示, 常见需求是同一处显示的附件来源较多,
  // 或者规则不统一, 在组件外查询后传入, 但使用协同云附件后本身支持多源查询, 因此filelist暂时不需要
  config.filelist = {
    list: params.filelist || ko.observableArray([]),
    newlist: [],// 新上传数据放入此数组 用于判断是否执行绑定操作
    dellist: []
  };
  if (config.inTable) {
    this.modalVisible = params.modalVisible || ko.observable(false);
    this.chooseText = params.chooseText || ko.observable(getLang('管理附件'));
    this.title = params.title || ko.observable(getLang('管理附件'));
    this.required = params.required || ko.observable(false);
    config.opened = false;
    this.showModal = function () {
      this.modalVisible(true);
    };
    this.modalVisible.subscribe(visible => {
      if (visible && !config.opened) {
        let id, fileid;
        if (config.type == 'businessId') {
          id = config.businessId();
          fileid = (config.isTemp||!id || id == '' || id == 0) ? this.tempId() : id;
        } else {
          id = config.id();
          fileid = (config.isTemp||!id || id == '' || id == 0) ? this.tempId() : params.groupname+id;
        }
        let objectName = params.objectName || defaultObjectName;
        config.fileid = fileid;
        config.objectName = objectName;
        setTimeout(() => {
          resetFile(this, params, config);
        },200);
      }
    });
  }
  try {
    config[config.type].subscribe(val => {
      // id变化两种情况 1  编辑   2 新增
      if (val) {
        if (this.fileCount() > 0 && !this.readonly()) {
          updateFile(this, params, config, true);
        } else {
          queryFile(this, params, config);
        }
      }
    });
  } catch (error) {
    console.log(error)
  }
   // 外部触发查询
   if (params.queryFile && ko.isObservable(params.queryFile)) {
    params.queryFile.subscribe(val => {
      if (val) {
        queryFile(this, params, config);
        params.queryFile(false);
      }
    });
  }
  // 手动触发绑定, 只有isTemp是true时有效
  if (params.bindFile && ko.isObservable(params.bindFile)) {
    params.bindFile.subscribe(val => {
      if (val) {
        updateFile(this, params, config, false, true);
        params.bindFile(false);
      }
    });
  }
  var subscription= this.readonly.subscribe(val=>{
    // 如果有初始化之后的回调
    if(fileInitCallBack){
      fileInitCallBack.update(
        {
          isSearch: false,
          listData: config.filelist.list(),
        },
      );
      // 动态控制上传组件中的所有按钮
      fileInitCallBack.updateAuth({
        auth: {
            canDownload : true,
            canDelete : !val,
            canUpload : !val,
            enablePersonalLimit: false
        } 
    })
  
    }
  })
  this.readonly._subscription = subscription
}

export {
  initVM,
  queryFile,
  clearFile,
  initTempId
}
