// <filesupload
//  params="
//    isDark:是否隐藏文件名
//    groupname:'bid_commerce',
//    id:model.ref('id'),
//    childid:子表id(传入时必须确定值,不允许后续再改动) //似乎没有用
//    index:0",//index 现在的作用其实是页面中的唯一id
//    readonly: vm(true/flase),支持直接传入true和false 和本地的this.readonly是两个值
//    filesize: vm//传入vm返回当前附件列表的数量
// >
import './fileupload.less'
import './fileintable.less'
import './yupload.less'
import { queryAllFilelist, updateFilelist, initFormData, deleteFilelistById, delteFile, getSocializationUrl } from './util'
import initWebuploader from './initwebuploader'
import layer from './layer'
import './skin/default/layer.css'
import _ from 'lodashmix'
import ko from 'knockout'
import getLang from './i18n'
import './transferdom'
import uuidv1 from 'uuid/v1'
import {entryCooper} from '../coop-fileupload/index'
import {entryCooperTable} from '../coop-fileupload/fileintable'
const ID_PREFIX = "uploader_"
let URL_PREFIX = '/yonbip-cpu-file/'
function getClientHeight()
{
  var clientHeight=0;
  if(document.body.clientHeight&&document.documentElement.clientHeight)
  {
  var clientHeight = (document.body.clientHeight<document.documentElement.clientHeight)?document.body.clientHeight:document.documentElement.clientHeight;
  }
  else
  {
  var clientHeight = (document.body.clientHeight>document.documentElement.clientHeight)?document.body.clientHeight:document.documentElement.clientHeight;
  }
  return clientHeight;
}
function entry (params) {
  params = _.extend({
    index: '',
    customOption: function () { },
    chooseText: getLang('管理附件'),
    index: 0,
    isDark: ko.observable(true)
  }, params)
  this.isCooper = params.isCooper || false
  this.getLang = getLang
  this.beforeUpload = params.beforeUpload
  this.afterDelete = params.afterDelete
  this.beforeDelete = params.beforeDelete
  this.customName = params.customName
  // 对index做一些初始化
  if (params.index) {
    if (params.index.subscribe) {
      params.index = params.groupname + params.index()
    } else {
      params.index = params.groupname + params.index
    }
  } else {
    params.index = params.groupname + 0
  }
  //  属性初始化
  this.handleClose = params.handleClose || function () { }
  this.filesize = params.filesize
  this.title = params.title
  this.filepath = params.filepath
  this.replace = !!params.replace
  this.duplicate = !!params.duplicate
  this.accept = params.accept
  this.fileSizeLimitInfo = params.fileSizeLimit ? getLang(`请选择${params.fileSizeLimit/1024/1024}M以内的附件！`,{fileLimit: params.fileSizeLimit/1024/1024 }) : getLang(`请选择100M以内的附件！`) //文件默认大小提示
  //domid改成使用uuid来生成，防止transform的指令把div生成到body下，导致重复的id
  this.domid = ko.observable(uuidv1())
  // 外层选择器唯一id TODO:确认是否多余
  this.el = "fileupload_" + params.index || '0'
  // 上传进度条宽度
  this.progresswidth = ko.observable('0%')
  var defaultReadOnly = ko.utils.unwrapObservable(params.readonly)
  // 用于判断是否只读
  this.readonly = ko.observable(defaultReadOnly)
  if (params.readonly) {
    // 如果readonly是ko对象
    if (params.readonly.subscribe) {
      params.readonly.subscribe(function (val) {
        if (val) {
          this.readonly(true)
        } else {
          this.readonly(false)
        }
      }.bind(this))
    } else {
      this.readonly(true)
    }
  }
  // 当前组件绑定的附件列表
  this.filelist = params.filelist || ko.observableArray([])
  this.fileLengthLimit = ko.observable(params.fileLengthLimit);
  // 用于同一个附件有两个来源的附件列表
  this.extrafilelist = ko.observableArray([])
  // 用友imgdisplay
  this.customOption = params.customOption
  var uploader
  // fileInTable 行内表明是否弹框
  this.isActive = ko.observable(false)
  this.isActive.subscribe(val => {
    // 多选情况比较复杂，暂不支持穿越overflowhidden
    if (val) {
      let el = params.$el.children[0]
      let position = el.getBoundingClientRect()
      var left = position.left
      var right = position.right
      var dropWidth = this.width() === '100%' ? el.offsetWidth : (this.width().toString().replace('px', '') - 0)
      // 如果距离右侧屏幕宽度小于250
      if (document.documentElement.clientWidth - position.left < dropWidth) {
        left = right - dropWidth
      }
      this.left(left)
      // select 默认高度 + 32
      this.top(position.top + 32)
    }
    if (val) {
      setTimeout(function () {
        // 性能优化，每个打开都要重新渲染
        uploader = initWebuploader(params.index, initFormData(typeof params.id == 'function' ? params.id() : params.id, params.groupname, params.isimg, '', params.isDark(), this), this.filelist, this.progresswidth, params.filesize, params.isimg, params.fileSizeLimit, params.fileLengthLimit, params.isDark(), params.fileNumLimit, this)
      }.bind(this))
    }
  })
  // fileInTable 外部显示文案
  this.chooseText = params.chooseText
  this.onUploadSuccess = params.onUploadSuccess
  // 如果带了prefix表示是主表id
  // this.prefix = params.childid ? (params.childid() + '') : ''

  // 计算属性
  // 主要用于fileInTable显示一共有几个附件
  this.size = ko.computed(function () {
    return this.filelist().filter(item => {
      return item.type !== '上传失败'
    }).length + this.extrafilelist().length
  }, this)
  // 判断何时隐藏附件组件，
  this.computedShowFile = ko.computed(function () {
    // readonly true时 且 附件数量为0时 才隐藏 其他时候都显示
    return !(this.readonly() && this.size() == 0)
  }, this)
  // ko 属性监听.subscribe
  // onlyfor image
  this.filelist.subscribe(function (value) {
    if (params.pics) {
      if (value.length > 0) {
        params.pics(value)
      }
    }
  })
  // 是否已经查询过
  var hasQuery = false
  
  this.id = params.id
  this.enterpriseId = params.enterpriseId
  this.tenantId = params.tenantId
  this.enableBuyerTenant = params.enableBuyerTenant
  if (params.id) {
    //因为是异步获取数据所以需要监听
    if (params.id.subscribe) {
      params.id.subscribe(function (val) {
        //只有当没有查询过而且val不为空才初始化（确保初始化的时候有id属性）
        if (!hasQuery && val) {
          //初始化webuploader
          uploader = initWebuploader(params.index, initFormData(val ? val : '', params.groupname, params.isimg, '', params.isDark(), this), this.filelist, this.progresswidth, params.filesize, params.isimg, params.fileSizeLimit, params.fileLengthLimit, params.isDark(), params.fileNumLimit, this)
        }
        //如果值不为空且没有查询过,则认为是第一次进入并查询
        //如果值不为空且已经查询过,则认为是回写id
        //如果值为空则表示不需要查询已经上传过的文件
        if (val) {
          //监听到有数据先判断当前有没有附件列表,没有则查询,有则修改
          if (this.filelist().length == 0) {
            //查询出所有的附件列表
            queryAllFilelist(params, val ? val : '', this.filelist, '', this.el)
          } else {
            //更新附件id
            updateFilelist(params, val ? val : '', this.filelist)
          }
          hasQuery = true;
        }

      }.bind(this))
    }
    // 为了表体行上的附件初始化用的,标题行上一开始就有id
    setTimeout(function () {
      //如果初始化的时候就有id值
      uploader = initWebuploader(params.index, initFormData(typeof params.id == 'function' ? params.id() : params.id, params.groupname, params.isimg, '', params.isDark(), this), this.filelist, this.progresswidth, params.filesize, params.isimg, params.fileSizeLimit, params.fileLengthLimit, params.isDark(), params.fileNumLimit, this)
      if (this.filelist().length == 0) {
        queryAllFilelist(params, typeof params.id == 'function' ? params.id() : params.id, this.filelist, '', this.el)
      } else { // 初始化
        uploader = initWebuploader(params.index, initFormData('', params.groupname, params.isimg, '', params.isDark(), this), this.filelist, this.progresswidth, params.filesize, params.isimg, params.fileSizeLimit, params.fileLengthLimit, params.isDark(), params.fileNumLimit, this)
      }
    }.bind(this), 0)
  }
  if (params.enterpriseId && params.enterpriseId.subscribe) {
    params.enterpriseId.subscribe(function (val) {
      if (val) {
        //监听到有数据先判断当前有没有附件列表,没有则查询,有则修改
        if (this.filelist().length == 0) {
          //查询出所有的附件列表
          queryAllFilelist(params, params.id(), this.filelist, '', this.el)
        }
      }
    }.bind(this))
  }
  // 支持enterpriseId和tenantId两种形式
  if (ko.isObservable(this.tenantId)) {
    this.tenantId.subscribe(val => {
      if (val) {
        //监听到有数据先判断当前有没有附件列表,没有则查询,有则修改
        if (this.filelist().length == 0) {
          //查询出所有的附件列表
          queryAllFilelist(params, params.id(), this.filelist, '', this.el)
        }
      }
    })
  }
  // methods
  // fineInTable 关闭
  this.maskclick = function () {
    $(".modalfileupload.active").removeClass('active')
    this.isActive(!(this.isActive()))
  }.bind(this)
  this.isFixPostion = ko.observable(false)
  this.top = ko.observable()
  this.left = ko.observable()
  this.width = ko.observable(200)
  // fineInTable 显示附件列表
  this.style = ko.computed(() => {
    let style = params.style || {}
    // width 支持ko和非ko对象
    if (this.width && this.width.subscribe) {
      // 存在传入 100%的情况
      if (isNaN(this.width())) {
        style.width = this.width()
      } else {
        style.width = this.width() + 'px'
      }
    }
    if (params.maxHeight) {
      style.maxHeight = params.maxHeight + 'px'
    }
    if (params.overflow) {
      style.overflow = params.overflow
    }
    if (this.top()) {
      var clientHeight = getClientHeight()
      var heightabs = this.top() - clientHeight + (this.size() > 6 ? 240 : 160)
      if (heightabs >= 0) {
        style.top = (this.top() - heightabs) + 'px'
      } else {
        style.top = this.top() + 'px'  
      }
      
      style.left = this.left() + 'px'
      style.position = 'fixed'
    } else {
      style.position = 'fixed'
    }
    return style
  })
  this.showmodal = function (data, e) {
    try {
      if ($(e.currentTarget).offset().left < 300) {
        this.isFixPostion(true)
      } else {
        this.isFixPostion(false)
      }
    } catch (e) {
      console.error(e)
    }
    if (this.size() === 0 && this.readonly()) {
      return ''
    }
    $(".modalfileupload.active").removeClass('active');
    this.isActive(!(this.isActive()))
  }.bind(this)
  // imgdispaly专属
  this.mouseover = function (vm, evt) {
    var el = $(evt.target)
    var nextel = el.next()
    var left = el.offset().left + el.width()
    var elheight = el.offset().top - $(document).scrollTop() + el.height() - nextel.height() / 2
    var top = elheight
    nextel.css({ left: left, top: top })
  }
  this.isPdfImgTxt = isPdfImgTxt
  var trueDownload = function (params, _data, isPreview) {
    let url
    let id = _data.fileid
    if (!params.isDark()) {
      $.ajax({
        url: URL_PREFIX + 'file/url?ids=' + id,
        type: 'get',
        xhrFields: {
          withCredentials: true
        },
        crossDomain: true,
        dataType : "json",
        success: function (data) {
          if (data.status == 1) {
            debugger
            var url = data.data[id]
            if (url.indexOf('http') == -1 && url.indexOf('https') == -1) {
              url = 'https://' + url
            }
            url = encodeURIComponent(url)
            url = document.location.origin + '/' + `cpu-score/scoreManage/getFileInfos?downLoadPath=${ url }&isDark=1`
            window.open(url, "下载", "");
          }
        }
      })
    } else {
      // 把附件下载改成url的方式 支持直接在新窗口中打开
      let name = _data.name
      let url = URL_PREFIX + 'file/urlForDownload?ids=' + id
      if (isPdfImgTxt(name.toLowerCase()) && isPreview) {
        url = URL_PREFIX + 'file/url?ids=' + id
      }
      $.ajax({
        url: url,
        type: 'get',
        xhrFields: {
          withCredentials: true
        },
        crossDomain: true,
        dataType : "json",
        success: function (data) {
          if (data.status == 1) {
            var url = data.data[id]
            if (url.indexOf('http') == -1 && url.indexOf('https') == -1) {
              url = 'https://' + url
            }
            window.open(url, getLang("下载"), "");
          }
        }
      })
    }
  }
  this.preview = function (_data, event) {
    // 如果要下载校验
    if (params.beforeDownload) {
      params.beforeDownload(function (flag) {
        if (!flag.status) {
          layer.msg(flag.msg || '文件拒绝下载！')
        } else {
          trueDownload(params, _data, true)
        }
      }, _data)
    } else {
      trueDownload(params, _data, true)
    }
  }
  //下载
  this.download = function (_data, event) {
    // 如果要下载校验
    if (params.beforeDownload) {
      debugger
      params.beforeDownload(function (flag) {
        if (!flag.status) {
          layer.msg(flag.msg || '文件拒绝下载！')
        } else {
          trueDownload(params, _data)
        }
      }, _data)
    } else {
      trueDownload(params, _data)
    }
  }
  this.deleteDirect = function (data, event) {
    this.delete(data, event, getLang("删除后不可恢复，请确认！"))
  }.bind(this)
  this.delete = function (data, event, text) {
    var _this = this;
    layer.confirm(text, {
      btn: [getLang('确定'), getLang('取消')] //按钮
    }, function () {
      //通过fileid来判断是否是已上传的附件
      if (data.fileid) {
        if (params.beforeDelete && typeof params.beforeDelete == 'function') { // 删除前回调函数
          let flag = params.beforeDelete(data)
          if (flag === false) {
            return false
          }
        }
        delteFile({
          id: data.fileid
        }, function () {
          if(params.afterDelete && typeof params.afterDelete == 'function'){ // 删除成功回调
            params.afterDelete(data)
          }
          deleteFilelistById(data.id, _this.filelist, uploader)
          if (params.filesize) {
            params.filesize(_this.filelist().length)
          }
        })
      } else {
        // 上传失败的附件，如同样的附件名已存在的附件
        deleteFilelistById(data.id, _this.filelist, uploader)
        if (params.filesize) {
          params.filesize(_this.filelist().length)
        }
      }
      layer.closeAll()
    })
  }.bind(this)
  // 初始化方法
  // 如果有多个id来源
  if (params.extraId) {
    // 确保组件渲染后再查询
    setTimeout(() => {
      queryAllFilelist(params, params.extraId(), this.extrafilelist, params.extragroupname, this.el)
    }, 0)
  }
}
function isPdfImgTxt (name) {
  if (name.endsWith('.jpg') || name.endsWith('.jpeg') || name.endsWith('.gif') || name.endsWith('.png') || name.endsWith('.bmp')) {
    return true
  }
  if (name.endsWith('.pdf')) {
    return true
  }
  if (name.endsWith('.txt')) {
    return true
  }
  return false
}
var init = {
  createViewModel: function (params, componentInfo) {
    params.$el = componentInfo.element
    params.$templateNodes = componentInfo.templateNodes
    if(params.enableBuyerTenant && !sessionStorage.getItem('socializationUrl')  && URL_PREFIX.indexOf('http') == -1){
      getSocializationUrl()
      URL_PREFIX = sessionStorage.getItem('socializationUrl') + URL_PREFIX
    }
    // TODO: 这里修改就可以了
    if (window.allUpdateCooFile){
        if (window.allUpdateCooFile[params.groupname]=='__inHeader') {
            params.isCooper = true
            return new entryCooper(params)
        } else if (window.allUpdateCooFile[params.groupname]=='__inTable'){
            return new entryCooperTable(params)
        } else {
            return new entry(params)
        }
    }else {
        return new entry(params)
    }

  }
}
export default init

