import webuploader from 'webuploader'
import { getfileimgcls, queryAllFilelist,validateFild, getCookie } from './util'
import layer from './layer'
import ko from 'knockout'
import getLang from './i18n'
const ID_PREFIX = "uploader_"
let URL_PREFIX = '/yonbip-cpu-file/'
function isValidateFileName (name) {
  for (var i = 0; i < name.length; i++) {
    if (name.charAt(i) == '@' || name.charAt(i) == '%' || name.charAt(i) == '#' || name.charAt(i) == '&' || name.charAt(i) == '+') {
      return false
    }
  }
  return true
}
function initWebuploader (index, formData, filelist, progresswidth_ko, filesize, isimg, fileSizeLimit, fileLengthLimit, isDark, fileNumLimit, context) {

  if(context.enableBuyerTenant && URL_PREFIX.indexOf('http') == -1){
    URL_PREFIX = sessionStorage.getItem('socializationUrl') + URL_PREFIX
  }
  console.log('%c 🍆 context: ', 'font-size:20px;background-color: #FFDD4D;color:#fff;', URL_PREFIX);
  var requesturl = URL_PREFIX + 'file/upload'
  if (context.replace) {
    requesturl = URL_PREFIX + 'file/replace'
  }
  var uploader = null
  if (isimg || !isDark) {
    uploader = webuploader.create({
      // swf文件路径,使用baidu的cdn
      swf: '/yonbip-cpu-portal/ucf-wh/cpu-portal/js/vendor/webuploader/Uploader.swf',
      formData: formData,
      // 文件接收服务端。
      server: requesturl,
      fileNumLimit: fileNumLimit,
      // fileSizeLimit: fileSizeLimit || 20 * 1024 * 1024,//限制大小20M，所有被选文件，超出选择不上
      fileSingleSizeLimit: fileSizeLimit || 20 * 1024 * 1024,//限制大小20M，所有被选文件，超出选择不上
      // 选择文件的按钮。可选。
      // 内部根据当前运行是创建，可能是input元素，也可能是flash.
      pick: '#' + context.domid(),

      // 不压缩image, 默认如果是jpeg，文件上传前会压缩一把再上传！
      resize: false,
      accept: {
        title: getLang('图片'),
        mimeTypes: 'image/bmp,image/gif,image/jpeg,image/jpg,image/png'
      },
      withCredentials: true
    })
  } else {
    var accept = null
    if (context.accept) {
      accept = context.accept
    }
    uploader = webuploader.create({
      // swf文件路径,使用baidu的cdn
      swf: '/cpu-portal-fe/js/vendor/webuploader/Uploader.swf',
      formData: formData,
      // 文件接收服务端。
      server: requesturl,
      fileNumLimit: fileNumLimit,
      // fileSizeLimit: fileSizeLimit || 100 * 1024 * 1024,//限制大小60M，所有被选文件，超出选择不上
      fileSingleSizeLimit: fileSizeLimit || 200 * 1024 * 1024,//限制大小60M，所有被选文件，超出选择不上
      // 选择文件的按钮。可选。
      // 内部根据当前运行是创建，可能是input元素，也可能是flash.
      pick: '#' + context.domid(),

      // 不压缩image, 默认如果是jpeg，文件上传前会压缩一把再上传！
      resize: false,
      duplicate: context.duplicate,
      accept: accept,
      withCredentials: true 
    })
  }
  // 将beforeUpload校验放到beforeFileQueued之中
  uploader.on('beforeFileQueued', function (file) {
    //上传之前先要检验 文件类型
    if(!validateFild(file.ext,['pdf','txt','zip','rar','xls','xlsx','ppt','pptx',
      'doc','docx','png','jpg','jpeg','bmp','gif','webp','dwg','p12'])){
      layer.msg(file.name + '错误的文件类型')
      uploader.removeFile(file);
      filelist.remove(function (item) {
        return item.id == file.id;
      });
      return false
    }
    var test = uploader.options;
    //大于10M   切不是fastdfs
    var obj = [];
    if(window.configObject.FILE_STORAGE_TYPE !== 'fastdfs' && (file.size > (10 * 1024 * 1024))){
    // if (true && (file.size > (10 * 1024 * 1024))) { // 专属化不走直传  公有云走obs 直传
      $.ajax({
        type: 'GET',
        async: false,
        xhrFields: {
          withCredentials: true
        },
        crossDomain: true,
        url: URL_PREFIX + 'file/oss',
        data: {
          tenantid: Common.userContext().tenantid, //这里是租户的id,需要自己处理
          permission: formData.permission, // read 公共 private 私有
          groupname: formData.groupname,
          filepath: formData.filepath,
          filename: file.name,
          isreplace: false,
          // sysid:
        },
        success: function (data) {
          obj = $.parseJSON(data);
        }
      });
      var ishttps = 'https:' == document.location.protocol ? true : false;
      var host = ishttps ? obj.host.replace('http', 'https') : obj.host
      uploader.option('server', host)
      uploader.options.formData = {}
      for (const key in obj) {
        uploader.options.formData[key] = obj[key]
      }
      delete uploader.options.formData['host']
    }else{
      uploader.option('server', requesturl)
      uploader.options.formData = formData
    }
    if (context.beforeUpload) {
      var flag = context.beforeUpload(file) // 返回格式{status: true, msg: 'error msg'}
      if (!flag.status) {
        layer.msg(flag.msg || '禁止上传文件')
        //throw  '禁止上传文件'
        return false
      }
    }
  })
  var lastTs = null
  // ie9 flash上传的时候默认使用accept: text/html,但服务端返回的是json/application
  uploader.on('uploadBeforeSend', function (obj, data, headers) {
    if(window.configObject.FILE_STORAGE_TYPE !== 'fastdfs' && (data.size > (10 * 1024 * 1024))){
      // if(true && (data.size > (10 * 1024 * 1024))){
      // obs 直传不需要这些参数 删除掉 如果存在会报错 上传失败
      delete data.size
      delete data.lastModifiedDate
      delete data.name
      delete data.id
      delete data.type
    }
    if (context.replace) {
      if (filelist().length > 0) {
        data.id = filelist()[0].id
      }
    }
    $.extend(headers, {
      Accept: '*/*'
    })
    // 添加csrf header
    var d = new Date().getTime()
    // 300ms更新token
    if (window.tnsSdk) {
      tnsSdk.writeXscfToken('AX')
    }
    var val = window.tnsSdk ? window.tnsSdk.readXscfToken() : getCookie('XSRF-TOKEN')
    if (val) {
      headers['X-XSRF-TOKEN'] = val
    }
    if (filelist && filelist().length > fileLengthLimit) {
      filelist.splice(filelist().length - 1, 1)
      uploader.trigger('error', 'EXCEED_MAXSIZE_SELFDEFINE')
      throw '文件数量超了'
    }
    if (!isValidateFileName(obj.file.name)) {
      var index = -1
      // 上传失败则删掉附件中的图片
      filelist().forEach(function (item, _index) {
        if (item.id == obj.file.id) {
          index = _index
        }
      })
      if (index >= 0) {
        try {
          // 已经存在的附件（通过查询而来的 删除的时候可能有问题）
          var deleteFile = filelist()[index]
          if (deleteFile && !deleteFile.setStatus) {
            deleteFile.setStatus = function () { }
          }
          uploader.removeFile(deleteFile, true);
        } catch (e) {
          console.error(e)
        }
        filelist.splice(index, 1)
      }
      uploader.trigger('error', 'ERROR_CHAR_SELFDEFINE')
      throw getLang('文件名不能包含下列字符：') + '@ % # & +'
    }
  })
  //  验证文件大小
  uploader.on('error', function (file) {
    if (file == 'Q_EXCEED_SIZE_LIMIT' || file == 'F_EXCEED_SIZE') {
      if (fileSizeLimit) {
        var size = fileSizeLimit / 1024 / 1024
        layer.msg('所选附件大小不允许超过'+ size +'M！')
      } else {
        layer.msg('所选附件大小不允许超过200M！')
      }
    } else if (file == 'EXCEED_MAXSIZE_SELFDEFINE') {
      layer.msg('所选附件数量不能超过' + fileLengthLimit)
    } else if (file == 'ERROR_CHAR_SELFDEFINE') {
      layer.msg(getLang('文件名不能包含下列字符：') + "@ % # & +")
    } else if (file == 'Q_EXCEED_NUM_LIMIT') {
      layer.msg(getLang('文件总数量不能超过：') + fileNumLimit)
    } else if (file == 'F_DUPLICATE') {
      layer.msg('不能上传相同附件！')
    } else {
      layer.msg(file)
    }
  })
  //监听附件上传事件
  uploader.on('fileQueued', function (file) {
    // 上传之前先要检验 文件总数量
    if (fileNumLimit) {
      if (filelist && filelist().length >= fileNumLimit) {
        layer.msg(getLang('文件总数量不能超过：') + fileNumLimit)
        return
      }
    }
    file.imgtype = getfileimgcls(file.name)
    file.type = getLang('等待上传')
    file.url = ko.observable('')
    filelist.push(file)
    uploader.upload()
  })
  uploader.on('uploadStart', function (file) {
    $('#' + file.id).find('.progress').addClass('active')
    $('#' + file.id).parents('.y-upload-ctn').find('.progress').addClass('active')
    if (context.replace) {
      var id = ''
      if (filelist().length > 0) {
        id = filelist()[0].id
      }
      console.log('%c 🍝 context: ', 'font-size:20px;background-color: #E41A6A;color:#fff;', context);
      // 第一次可能没有id，那么则不需要替换，直接上传
      if (id && id.indexOf('WU_FILE') >= 0) {
        uploader.options.server = URL_PREFIX + 'file/upload'
        
      } else {
        uploader.options.server = URL_PREFIX + 'file/replace'
      }
    }
  })

  //监听上传事件 进度条
  uploader.on('uploadProgress', function (file, percentage) {
    progresswidth_ko(percentage * 100 + '%')
  })
  //上传成功后事件
  uploader.on('uploadSuccess', function (file, response) {
    if (response.status == 1) {
      $('#' + file.id).find('p.state').text('')
      $('#' + file.id).find('.file-error').text(response.message)
      $('#' + file.id).parents('.y-upload-ctn').find('p.state').text('')
      var filelength = 0
      var fileID = null
      if (context.replace) {
        if (filelist().length > 1) {
          filelist.splice(0, 1)
        }
        fileID = response.data[0].id
      }
      //原来filelist中存的是webupload的id,需要改成response返回的id
      filelist().forEach(function (item, index) {
        if (item.id == file.id) {
          var _data = response.data[0]
          if (context.replace) {
            item.oldId = item.id
            item.id = fileID
          }
          item.fileid = _data.id
          item.filepath = _data.filepath
          item.groupname = _data.groupname
          var _url = (_data.url.indexOf('http:') >= 0 || _data.url.indexOf('https:') >= 0)? _data.url : ('http://' + _data.url)
          // permission private的时候的bug
          _url.replace("http://http://", "http://")
          _url.replace("http://https://", "https://")
          item.url(_url)
          item.filename = _data.filename
          item.loaded = 1
          if (context.customName) {
            item.name = context.customName(item, index)
          }
          item.type = ''
          // 计算md5file
          // uploader.md5File( file )
          // // 及时显示进度
          //   .progress(function(percentage) {
          //     console.log('Percentage:', percentage);
          //   })
          //   // 完成
          //   .then(function(val) {
          //     console.log('md5 result:', val + 'id:' + _data.id);
          //   });
        }
        if (item.loaded) {
          filelength++
        }
      })
      if (filesize) {
        filesize(filelength)
      }
      var files = filelist()
      filelist([])
      filelist(files)
      context.onUploadSuccess && context.onUploadSuccess(file)
    } else {
      uploader.trigger('error', response.message)
      file.type = getLang('上传失败')
      // 触发filesize重新计算
      filelist.splice(0, 0)
      $('#' + file.id).find('.file-error').text(response.message)
      $('#' + file.id).find('p.state').text(response.message)
      $('#' + file.id).find('.nouploaded').removeClass('nouploaded')
    }
  })
  //上传失败后事件
  uploader.on('uploadError', function (file) {
    uploader.removeFile(file, true);
    filelist.remove(function (item) {
      return item.id == file.id;
    });
    layer.msg('上传出错！')
    // $('#' + file.id).find('p.state').text(getLang('上传出错'))
    // $('#' + file.id).parents('.y-upload-ctn').find('p.state').text(getLang('上传出错'))
  })
  //上传完毕事件
  uploader.on('uploadComplete', function (file) {
    file.type = ''
    $('#' + file.id).find('.progress').fadeOut()
    if (context.replace) {
      $('#' + file.oldId).find('.progress').fadeOut()
    }
    $('#' + file.id).parents('.y-upload-ctn').find('.progress').fadeOut()
  })
  return uploader
}
export default initWebuploader