import { queryAllFilelist, getSocializationUrl } from './util'
import _ from 'lodashmix'
import ko from 'knockout'
import getLang from './i18n'
import uuidv1 from 'uuid/v1'

const ID_PREFIX = 'uploader_'
let URL_PREFIX = '/yonbip-cpu-file/'
function entry(params) {
  if(params.enableBuyerTenant  && URL_PREFIX.indexOf('http') == -1) {
    URL_PREFIX = sessionStorage.getItem('socializationUrl') + URL_PREFIX
  }
  params = _.extend(
    {
      index: '',
      customOption: function () {},
      chooseText: getLang('管理附件'),
      index: 0,
      isDark: ko.observable(true),
    },
    params
  )
  this.getLang = getLang
  // 对index做一些初始化
  if (params.index) {
    if (params.index.subscribe) {
      params.index = params.groupname + params.index()
    } else {
      params.index = params.groupname + params.index
    }
  } else {
    params.index = params.groupname + 0
  }
  //  属性初始化
  this.handleClose = params.handleClose || function () {}
  this.filesize = params.filesize
  this.title = params.title
  this.filepath = params.filepath
  //domid改成使用uuid来生成，防止transform的指令把div生成到body下，导致重复的id
  this.domid = ko.observable(uuidv1())
  // 外层选择器唯一id TODO:确认是否多余
  this.el = 'fileupload_' + params.index || '0'
  // 当前组件绑定的附件列表
  this.filelist = ko.observableArray([])

  // fileInTable 行内表明是否弹框
  this.isActive = ko.observable(false)
  this.isActive.subscribe((val) => {
    // 多选情况比较复杂，暂不支持穿越overflowhidden
    if (val) {
      let el = params.$el.children[0]
      let position = el.getBoundingClientRect()
      var left = position.left
      var right = position.right
      var dropWidth =
        this.width() === '100%'
          ? el.offsetWidth
          : this.width().toString().replace('px', '') - 0
      // 如果距离右侧屏幕宽度小于250
      if (document.documentElement.clientWidth - position.left < dropWidth) {
        left = right - dropWidth
      }
      this.left(left)
      // select 默认高度 + 32
      this.top(position.top + 32)
    }
  })
  // fileInTable 外部显示文案
  this.chooseText = params.chooseText
  this.size = ko.computed(function () {
    return this.filelist().length
  }, this)
  // 是否已经查询过
  var hasQuery = false
  this.id = params.id
  this.enterpriseId = params.enterpriseId
  this.tenantId = params.tenantId
  if (params.id) {
    if (this.filelist().length == 0) {
      queryAllFilelist(
        params,
        typeof params.id == 'function' ? params.id() : params.id,
        this.filelist,
        '',
        this.el
      )
    }
  }
  // methods
  // fineInTable 关闭
  this.maskclick = function () {
    this.isActive(!this.isActive())
  }.bind(this)
  this.isFixPostion = ko.observable(false)
  this.top = ko.observable()
  this.left = ko.observable()
  this.width = ko.observable(200)
  // fineInTable 显示附件列表
  this.style = ko.computed(() => {
    let style = params.style || {}
    // width 支持ko和非ko对象
    if (this.width && this.width.subscribe) {
      // 存在传入 100%的情况
      if (isNaN(this.width())) {
        style.width = this.width()
      } else {
        style.width = this.width() + 'px'
      }
    }
    if (params.maxHeight) {
      style.maxHeight = params.maxHeight + 'px'
    }
    if (params.overflow) {
      style.overflow = params.overflow
    }
    if (this.top()) {
      style.top = this.top() + 'px'
      style.left = this.left() + 'px'
      style.position = 'fixed'
    } else {
      style.position = 'fixed'
    }
    return style
  })
  this.showmodal = function (data, e) {
    try {
      if ($(e.currentTarget).offset().left < 300) {
        this.isFixPostion(true)
      } else {
        this.isFixPostion(false)
      }
    } catch (e) {
      console.error(e)
    }
    if (this.size() === 0) {
      return ''
    }
    this.isActive(!this.isActive())
  }.bind(this)
  var trueDownload = function (params, _data) {
    let url
    let id = _data.fileid
    // 把附件下载改成url的方式 支持直接在新窗口中打开
    $.ajax({
      url:  URL_PREFIX + 'file/urlForDownload?id=' + id,
      type: 'get',
      xhrFields: {
        withCredentials: true
      },
      crossDomain: true,
      dataType : "json",
      success: function (data) {
        if (data.status == 1) {
          var url = data.data[id]
          if (url.indexOf('http') == -1 && url.indexOf('https') == -1) {
            url = 'http://' + url
          }
          window.open(url, getLang("下载"), "");
        }
      }
    })
  }
  //下载
  this.download = function (_data, event) {
    // 如果要下载校验
    if (params.beforeDownload) {
      debugger
      params.beforeDownload(function (flag) {
        if (!flag.status) {
          layer.msg(flag.msg || '文件拒绝下载！')
        } else {
          trueDownload(params, _data)
        }
      }, _data)
    } else {
      trueDownload(params, _data)
    }
  }
}
var init = {
  createViewModel: function (params, componentInfo) {
    params.$el = componentInfo.element
    params.$templateNodes = componentInfo.templateNodes
    return new entry(params)
  },
}
export default init
