import ko from 'knockout'
function getTarget (node) {
  return document.body
}
if (!ko.bindingHandlers.transferdom) {
  ko.bindingHandlers.transferdom = {
    init: function (el, value, allBindings, viewModel, bindingContext) {
      el.className = el.className ? el.className + ' v-transfer-dom' : 'v-transfer-dom';
      const parentNode = el.parentNode;
      if (!parentNode) return;
      const home = document.createComment('');
      let hasMovedOut = false;

      if (value() !== false) {
        parentNode.replaceChild(home, el); // moving out, el is no longer in the document
        getTarget().appendChild(el); // moving into new place
        hasMovedOut = true
      }
      if (!el.__transferDomData) {
        el.__transferDomData = {
          parentNode: parentNode,
          home: home,
          target: getTarget(),
          hasMovedOut: hasMovedOut
        }
      }
    },
    update: function (el, value, allBindings, viewModel, bindingContext) {
      // 某些场景可能el不存在
      if (el.dataset && el.dataset.transfer !== 'true') return false;
      // need to make sure children are done updating (vs. `update`)
      const ref$1 = el.__transferDomData;
      if (!ref$1) return;
      // homes.get(el)
      const parentNode = ref$1.parentNode;
      const home = ref$1.home;
      const hasMovedOut = ref$1.hasMovedOut; // recall where home is

      if (!hasMovedOut && value()) {
        // remove from document and leave placeholder
        parentNode.replaceChild(home, el);
        // append to target
        getTarget().appendChild(el);
        el.__transferDomData = Object.assign({}, el.__transferDomData, { hasMovedOut: true, target: getTarget(value) });
      } else if (hasMovedOut && value() === false) {
        // previously moved, coming back home
        parentNode.replaceChild(el, home);
        el.__transferDomData = Object.assign({}, el.__transferDomData, { hasMovedOut: false, target: getTarget(value) });
      } else if (value()) {
        // already moved, going somewhere else
        getTarget().appendChild(el);
      }
    }
  }
}
