import fileService from './fileService'
import _ from 'lodashmix'
import ko from 'knockout'
let URL_PREFIX = '/yonbip-cpu-file/'
var user = window.localStorage.getItem('user')
var enterprise = window.localStorage.getItem('enterprise')
// 不能从cookie获取cookie不可靠
function getTenantId () {
  if (!user || !enterprise || user == 'undefined' || enterprise == 'undefined') {
    let data = $.ajax({
      url: "/yonbip-cpu-portal/yuncai/ebvplogin",
      type: "get",
      async: false
    }).responseText
    data = JSON.parse(data)
    if (!data.needrelogin) {
      user = JSON.stringify(data)
      enterprise =JSON.stringify(data.enterprise)
      window.localStorage.setItem('user', user)
      window.localStorage.setItem('enterprise', enterprise)
    }
  }
  // 融合前user和enterprise都放了，融合后只放了user，user里包含enterprise
  let userContext = JSON.parse(user)
  if (userContext.user && userContext.user.tenantid) {
    return userContext.user.tenantid
  }
  let enterpriseContext
  // 如果user里有enterprise 优先enterprise取user的
  if (userContext && userContext.enterprise) {
    enterpriseContext = userContext.enterprise
  } else if (typeof enterprise === 'string' || enterprise != 'undefined') {
    enterpriseContext = JSON.parse(enterprise)
  }
  if (enterpriseContext && enterpriseContext.tenantid) {
    return enterpriseContext.tenantid
  }
  return null
}
function queryTenantIdByEnterpriseId (enterpriseId) {
  //把数据缓存到sessionstorage之中
  var enterpriseMapList = window.sessionStorage.mapTenantId ? JSON.parse(window.sessionStorage.mapTenantId) : {}
  if (enterpriseMapList && enterpriseMapList[enterpriseId]) {
    return enterpriseMapList[enterpriseId]
  } else {
    try {
      var responseData = JSON.parse($.ajax({
        url: "/yonbip-cpu-bctask/enterprise/getById?id=" + enterpriseId,
        type: "get",
        async: false
      }).responseText)

      var tenantid = null
      if (responseData.data && responseData.data.tenantid) {
        tenantid = responseData.data.tenantid
      } else {
        tenantid = responseData.tenantid
      }
      if (!enterpriseMapList) {
        enterpriseMapList = {}
      }
      enterpriseMapList[enterpriseId] = tenantid;
      window.sessionStorage.mapTenantId = JSON.stringify(enterpriseMapList);
      return tenantid;
    } catch (e) {
      return ""
    }
  }
}

//查询所有已上传附件,extragroupname:可能有多个来源
export function queryAllFilelist (params, val, filelist_ko, extragroupname, el) {
  // 如果传入的单据id是null或者空字符串，那么则没有发起查询的必要了（现有逻辑在子表的时候，会发起查询）
  if (val === null || val === '' || val === undefined) {
    return ''
  }
  var tenantId = getTenantId()
  // 判断是否查询其他租户下的附件
  if (params.enterpriseId && typeof params.enterpriseId === 'function') {
    // 如果租户id是动态的，则第一次不查询，第二次才ko对象里有值查询
    if (params.enterpriseId()) {
      tenantId = queryTenantIdByEnterpriseId(params.enterpriseId())
    } else {
      // 如果enterpriseId没有值则不执行附件查询
      return
    }
  }
  if (ko.isObservable(params.tenantId)) {
    var _tenantId = params.tenantId.peek()
    if (_tenantId) {
      tenantId = _tenantId
    }
  }
  var par = {
    cross_url: URL_PREFIX,
    filepath: (extragroupname ? extragroupname : params.groupname) + val,
    groupname: extragroupname ? extragroupname : params.groupname,
    tenant: tenantId
  }
  if (params.filepath) {
    par.filepath = params.filepath()
  }
  var callback = function (response) {
    if (response.status == 1) {
      //清空列表 fix bug 有时候不带id的查询速度慢，带id的查询速度快，所以只有查询到了之后才进行清除并重新赋值
      filelist_ko([])
      response.data.forEach(function (data, index) {
        var url = (data.url.indexOf('http') >= 0 || data.url.indexOf('https') >= 0) ? data.url : ('http://' + data.url).replace('http://http://', 'http://').replace('http://https://', 'https://')
        var item = {
          name: data.filename,
          filepath: data.filepath,
          filesize: data.filesize,
          groupname: data.groupname,
          fileid: data.id,
          id: data.id,
          uploadtime: data.uploadtime || '',
          url: url,
          imgtype: getfileimgcls(data.filename),
          type: '',
          loaded: 1
        }
        if (!params.isDark()) {
          item.name = "***"
        }
        if (params.customName) {
          var showName = params.customName(item, index)
          item.name = showName
        }
        filelist_ko.push(item)
      })
      if (params.filesize) {
        // 可能有多个来源 有场景会把默认设置成-1 来确保在附件加载完之后返回
        if (params.filesize() != filelist_ko().length) {
          var oldValue = params.filesize()
          oldValue = oldValue > 0 ? oldValue : 0
          params.filesize(oldValue + filelist_ko().length)
        }
      }
    } else {
      if (params.filesize) {
        params.filesize(0)
      }
    }
  }
  // 大于0 是fileintable
  if ($("#" + el).find('.isFileInTable').length > 0) {
    fileService.multiQuery(par, callback)
  } else {
    fileService.query(par, callback)
  }
}
//更新附件filepath
export function updateFilelist (params, val, filelist) {
  for (var i = 0; i < filelist().length; i++) {
    //如果有传入filepath那么要以传入的为准，只查询不更新
    if (params.filepath) {
      return
    }
    //如果filepath一样那就不用更新了
    if (filelist()[i].filepath != params.groupname + val) {
      var par = {
        cross_url: URL_PREFIX,
        id: filelist()[i].fileid,
        filepath: params.groupname + val,
        groupname: params.groupname
      };
      fileService.update(par, function (data) {
        if (data.status == 1) {
          console.log("update success!");
        } else {
          console.log("update fail!" + data)
        }
      });
    }
  }
}
// 生成待提交的formData
export function initFormData (filepath, groupname, isimg, thumbnail, isDark, context) {
  var _filepath = groupname + ((filepath && filepath != 'null') ? filepath : (new Date()).getTime());   //【必填】单据相关的唯一标示，一般包含单据ID，如果有多个附件的时候由业务自己制定规则
  if (context.filepath) {
    _filepath = context.filepath()
  }
  var formData = {
    filepath: _filepath,
    groupname: groupname,//【必填】分組名称,未来会提供树节点
    permission: (isimg || !isDark) ? 'read' : 'private', //【选填】 read是可读=公有     private=私有     当这个参数不传的时候会默认private
    url: true,          //【选填】是否返回附件的连接地址，并且会存储到数据库
    thumbnail: thumbnail,//【选填】缩略图--可调节大小，和url参数配合使用，不会存储到数据库
    isencrypt: false,  //【选填】文件加密，若是设置为true，则会对文件进行加密后上传，下载需解密
    tenantid: getTenantId() // 所有的上传都应该传到当前租户，不应该支持根据cookie获取租户
    //cross_url : "http://localhost:8081/iuap-saas-fileservice-base/" //【选填】跨iuap-saas-fileservice-base 时候必填
  }
  return formData
}
//获取上传附件图片的类型
export function getfileimgcls (name) {
  var result
  result = judgeFileTpe(name, ['.png', '.jpg', '.gif', '.jpeg', '.tif'], 'image')
  if (!result)
    result = judgeFileTpe(name, ['.doc', '.docx'], 'doc')
  if (!result)
    result = judgeFileTpe(name, ['.xls', '.xlsx'], 'xls')
  if (!result)
    result = judgeFileTpe(name, ['.ppt', '.pptx'], 'ppt')
  if (!result)
    result = judgeFileTpe(name, ['.txt'], 'txt')
  if (!result)
    result = judgeFileTpe(name, ['.zip', '.rar'], 'zip')
  if (!result)
    result = 'link'
  return 'fileicon-' + result
}

//过滤附件
export function validateFild (ext,typs) {
  var isShow = false
  isShow = typs.includes(ext)
  if(!isShow && parseInt(ext)){
    isShow = (parseInt(ext) < 1000)
  }
  return isShow
}

export function deleteFilelistById (id, filelist, uploader) {
  var index
  filelist().forEach(function (item, _index) {
    if (item.id == id) {
      index = _index
    }
  })
  if (index >= 0) {
    try {
      var deleteFile = filelist()[index]
      if (deleteFile && !deleteFile.setStatus) {
        deleteFile.setStatus = function () { }
      }
      uploader.removeFile(deleteFile, true);
    } catch (e) {
      console.error(e)
    }
    filelist.splice(index, 1)
  }
}
//将扩展名与文件类型比较
function judgeFileTpe (name, array, type) {
  var result = '';
  array.forEach(function (item) {
    if (_.endsWith(_.toLower(name), item)) {
      result = type
    }
  })
  return result;
}
// 附件删除
export function delteFile (params, callback) {
  var par = {
    id: params.id,
    cross_url: URL_PREFIX
  }
  fileService.deletefile(par, function (data) {
    if (data.status == 1) {
      callback()
    } else {
      //iuap的file存在问题有可能已经删除了但是没有返回正确的状态（先复制 在 删除复制出的附件的场景）
      if (data.message.indexOf('已被删除') >= 0) {
        console.error(data.message)
        callback()
      }
    }
  })
}

export function getSocializationUrl () {
  $.ajax({
    type: 'GET',
    async: false,
    url: '/yonbip-cpu-portal/yuncai/tenant/getXtDomainUrl',
    success: function (result) {
      var {code, data} = result
      if(code == 200){
        sessionStorage.setItem('socializationUrl', data)
        if(URL_PREFIX.indexOf('http') == -1)
        URL_PREFIX = data + URL_PREFIX
      }
    }
  })
}
export function getCookie (key) {
  return fileService.getcookie(key)
}